﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using PowerPoint = Microsoft.Office.Interop.PowerPoint;
using System.Collections.Generic;
using System.Linq;

namespace ScheduledPPT
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("E92329D4-6731-41A6-87D2-F84D0B1C5B1F"), ProgId("ScheduledPPT.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private AddinExpress.PP.ADXPowerPointTaskPanesManager adxPowerPointTaskPanesManager1;
        private AddinExpress.PP.ADXPowerPointTaskPanesCollectionItem adxPowerPointTaskPanesCollectionItem1;
        public List<SlideSchedule> Schedule = new List<SlideSchedule>();
        private ADXRibbonTab scheduleRibbonTab;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonButton runWithScheduleRibbonButton;
        private ImageList imlIcons;
        private Timer timerSchedule;
        private Timer timerSlide;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.adxPowerPointTaskPanesManager1 = new AddinExpress.PP.ADXPowerPointTaskPanesManager(this.components);
            this.adxPowerPointTaskPanesCollectionItem1 = new AddinExpress.PP.ADXPowerPointTaskPanesCollectionItem(this.components);
            this.scheduleRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.runWithScheduleRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.imlIcons = new System.Windows.Forms.ImageList(this.components);
            this.timerSchedule = new System.Windows.Forms.Timer(this.components);
            this.timerSlide = new System.Windows.Forms.Timer(this.components);
            // 
            // adxPowerPointTaskPanesManager1
            // 
            this.adxPowerPointTaskPanesManager1.Items.Add(this.adxPowerPointTaskPanesCollectionItem1);
            this.adxPowerPointTaskPanesManager1.SetOwner(this);
            // 
            // adxPowerPointTaskPanesCollectionItem1
            // 
            this.adxPowerPointTaskPanesCollectionItem1.AlwaysShowHeader = true;
            this.adxPowerPointTaskPanesCollectionItem1.Position = AddinExpress.PP.ADXPowerPointTaskPanePosition.Right;
            this.adxPowerPointTaskPanesCollectionItem1.TaskPaneClassName = "ScheduledPPT.SchedulePane";
            this.adxPowerPointTaskPanesCollectionItem1.UseOfficeThemeForBackground = true;
            // 
            // scheduleRibbonTab
            // 
            this.scheduleRibbonTab.Caption = "Schedule";
            this.scheduleRibbonTab.Controls.Add(this.adxRibbonGroup1);
            this.scheduleRibbonTab.Id = "adxRibbonTab_cb401a69afb34bcc920e87b90ca0783a";
            this.scheduleRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "Schedule";
            this.adxRibbonGroup1.Controls.Add(this.runWithScheduleRibbonButton);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_af6d591ef09a44c494696cbf5f2601fc";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation;
            // 
            // runWithScheduleRibbonButton
            // 
            this.runWithScheduleRibbonButton.Caption = "Run with Schedule";
            this.runWithScheduleRibbonButton.Id = "adxRibbonButton_3f721d525d2347d597d3c5159106ebf3";
            this.runWithScheduleRibbonButton.Image = 0;
            this.runWithScheduleRibbonButton.ImageList = this.imlIcons;
            this.runWithScheduleRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.runWithScheduleRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation;
            this.runWithScheduleRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.runWithScheduleRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.runWithScheduleRibbonButton_OnClick);
            // 
            // imlIcons
            // 
            this.imlIcons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imlIcons.ImageStream")));
            this.imlIcons.TransparentColor = System.Drawing.Color.Transparent;
            this.imlIcons.Images.SetKeyName(0, "clock_go.png");
            // 
            // timerSchedule
            // 
            this.timerSchedule.Interval = 10000;
            this.timerSchedule.Tick += new System.EventHandler(this.timerSchedule_Tick);
            // 
            // timerSlide
            // 
            this.timerSlide.Interval = 1000;
            this.timerSlide.Tick += new System.EventHandler(this.timerSlide_Tick);
            // 
            // AddinModule
            // 
            this.AddinName = "ScheduledPPT";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaPowerPoint;

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public PowerPoint._Application PowerPointApp
        {
            get
            {
                return (HostApplication as PowerPoint._Application);
            }
        }

        private void runWithScheduleRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            timerSchedule.Enabled = true;
            timerSchedule.Start();
        }

        PowerPoint.SlideShowWindow slideShowWindow = null;

        private void timerSchedule_Tick(object sender, EventArgs e)
        {
            PowerPoint.DocumentWindow activeWindow = null;
            PowerPoint.Presentation activePresentation = null;
            PowerPoint.View activeView = null;
            PowerPoint.SlideShowSettings slideShowSettings = null;
            PowerPoint.SlideShowView slideShowView = null;
            SlideSchedule slideSchedule = null;

            try
            {
                slideSchedule = Schedule.FirstOrDefault(s => s.ShowAt.Hour == DateTime.Now.Hour && s.ShowAt.Minute == DateTime.Now.Minute);
                if (slideSchedule != null)
                {
                    activePresentation = PowerPointApp.ActivePresentation;
                    activeWindow = PowerPointApp.ActiveWindow;
                    activeView = activeWindow.View;

                    slideShowSettings = activePresentation.SlideShowSettings;

                    slideShowSettings.EndingSlide = slideSchedule.SlideIndex;
                    activePresentation.Save();
                    slideShowWindow = slideShowSettings.Run();

                    slideShowView = slideShowWindow.View;
                    slideShowView.GotoSlide(slideSchedule.SlideIndex);

                    timerSlide.Enabled = true;
                    timerSlide.Interval = slideSchedule.ShowFor * 60000;
                    timerSlide.Start();
                    timerSchedule.Stop();
                }
            }
            finally
            {
                if (slideShowSettings != null)
                    Marshal.ReleaseComObject(slideShowSettings);
                if (activeView != null)
                    Marshal.ReleaseComObject(activeView);
                if (activePresentation != null)
                    Marshal.ReleaseComObject(activePresentation);
                if (activeWindow != null)
                    Marshal.ReleaseComObject(activeWindow);
                if (slideShowView != null)
                    Marshal.ReleaseComObject(slideShowView);
            }
        }


        private void timerSlide_Tick(object sender, EventArgs e)
        {
            PowerPoint.SlideShowView slideShowView = null;
            try
            {
                timerSlide.Stop();
                slideShowView = slideShowWindow.View;
                slideShowView.Exit();
                timerSchedule.Start();
            }
            finally
            {
                if (slideShowView != null)
                    Marshal.ReleaseComObject(slideShowView);
            }
        }

    }
}

